<html>
<head>
<title>OgreMaterialSerializer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMaterialSerializer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMaterialSerializer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __MaterialSerializer_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __MaterialSerializer_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreMaterial_8h.html">OgreMaterial.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreBlendMode_8h.html">OgreBlendMode.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreTextureUnitState_8h.html">OgreTextureUnitState.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringVector_8h.html">OgreStringVector.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00047"></a><a class="code" href="group__Materials.html#ga83c5c9e6cd44a657c97dd7494800676c">00047</a>     <span class="keyword">enum</span> <a class="code" href="group__Materials.html#ga83c5c9e6cd44a657c97dd7494800676c" title="Enum to identify material sections.">MaterialScriptSection</a>
<a name="l00048"></a>00048     {
<a name="l00049"></a><a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676caa8ecf2298f0401fa132fbe09d7306e22">00049</a>         <a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676caa8ecf2298f0401fa132fbe09d7306e22">MSS_NONE</a>,
<a name="l00050"></a><a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676ca03535ff3b3deaf08ce6e4cf28f247396">00050</a>         <a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676ca03535ff3b3deaf08ce6e4cf28f247396">MSS_MATERIAL</a>,
<a name="l00051"></a><a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676ca75dcdf27cd2c26a79997de2e6670f4a1">00051</a>         <a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676ca75dcdf27cd2c26a79997de2e6670f4a1">MSS_TECHNIQUE</a>,
<a name="l00052"></a><a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676ca4dbef3e527e942ad0fdf8790ff79ca91">00052</a>         <a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676ca4dbef3e527e942ad0fdf8790ff79ca91">MSS_PASS</a>,
<a name="l00053"></a><a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676caf7bf31ae13f2c3b042d78aa28626b1e5">00053</a>         <a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676caf7bf31ae13f2c3b042d78aa28626b1e5">MSS_TEXTUREUNIT</a>,
<a name="l00054"></a><a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676cac22fc0112f378c4652e0335c5369a501">00054</a>         <a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676cac22fc0112f378c4652e0335c5369a501">MSS_PROGRAM_REF</a>,
<a name="l00055"></a><a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676ca1482036b89dfe855d5722f4280bb9136">00055</a>         <a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676ca1482036b89dfe855d5722f4280bb9136">MSS_PROGRAM</a>,
<a name="l00056"></a><a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676ca485e4dd851bfd5d5db3ca78b4a031d44">00056</a>         <a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676ca485e4dd851bfd5d5db3ca78b4a031d44">MSS_DEFAULT_PARAMETERS</a>,
<a name="l00057"></a><a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676cadd3efa1f0af549e1fbe112beb544bf69">00057</a>         <a class="code" href="group__Materials.html#gga83c5c9e6cd44a657c97dd7494800676cadd3efa1f0af549e1fbe112beb544bf69">MSS_TEXTURESOURCE</a>
<a name="l00058"></a>00058     };
<a name="l00060"></a><a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html">00060</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html" title="Struct for holding a program definition which is in progress.">MaterialScriptProgramDefinition</a>
<a name="l00061"></a>00061     {
<a name="l00062"></a><a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#ad766f0b063f8753dbfdbb04b1e05d2a1">00062</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#ad766f0b063f8753dbfdbb04b1e05d2a1">name</a>;
<a name="l00063"></a><a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#a71d6628fda7a428d149f7f53dcbf86dc">00063</a>         <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> <a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#a71d6628fda7a428d149f7f53dcbf86dc">progType</a>;
<a name="l00064"></a><a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#a634973d853b04b2cf2af2133d504b257">00064</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#a634973d853b04b2cf2af2133d504b257">language</a>;
<a name="l00065"></a><a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#acb6cf4f2d3a5fdaff51d6ca169ad0fc0">00065</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#acb6cf4f2d3a5fdaff51d6ca169ad0fc0">source</a>;
<a name="l00066"></a><a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#a8392666564161eed2e77efed86ead9fd">00066</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#a8392666564161eed2e77efed86ead9fd">syntax</a>;
<a name="l00067"></a><a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#ae1581e882fed968d73656a5a389679ca">00067</a>         <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#ae1581e882fed968d73656a5a389679ca">supportsSkeletalAnimation</a>;
<a name="l00068"></a><a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#a7d0607b541edd5abfc19a1e933eed431">00068</a>         <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#a7d0607b541edd5abfc19a1e933eed431">supportsMorphAnimation</a>;
<a name="l00069"></a><a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#aceffe25ef1a661814764abcff14693a3">00069</a>         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#aceffe25ef1a661814764abcff14693a3">supportsPoseAnimation</a>; <span class="comment">// number of simultaneous poses supported</span>
<a name="l00070"></a><a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#a4fdff24708148cef3ede00b2e6abade8">00070</a>         <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#a4fdff24708148cef3ede00b2e6abade8">usesVertexTextureFetch</a>;
<a name="l00071"></a><a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#ab9154054c102527e0eb595216ddd6c86">00071</a>         <a class="code" href="structOgre_1_1vector.html">vector&lt;std::pair&lt;String, String&gt;</a> &gt;::type <a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html#ab9154054c102527e0eb595216ddd6c86">customParameters</a>;
<a name="l00072"></a>00072     };
<a name="l00074"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html">00074</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1MaterialScriptContext.html" title="Struct for holding the script context while parsing.">MaterialScriptContext</a> 
<a name="l00075"></a>00075     {
<a name="l00076"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#ad40690e3e1f21dd8dcfa844eaa905bd5">00076</a>         <a class="code" href="group__Materials.html#ga83c5c9e6cd44a657c97dd7494800676c" title="Enum to identify material sections.">MaterialScriptSection</a> <a class="code" href="structOgre_1_1MaterialScriptContext.html#ad40690e3e1f21dd8dcfa844eaa905bd5">section</a>;
<a name="l00077"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#a2faaff5fc2f2076677693f6076374ea5">00077</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1MaterialScriptContext.html#a2faaff5fc2f2076677693f6076374ea5">groupName</a>;
<a name="l00078"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#a74312b6a7b96872915da5f6ec8541f37">00078</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="structOgre_1_1MaterialScriptContext.html#a74312b6a7b96872915da5f6ec8541f37">material</a>;
<a name="l00079"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#a03a912b72b369693e36167459bda916d">00079</a>         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* <a class="code" href="structOgre_1_1MaterialScriptContext.html#a03a912b72b369693e36167459bda916d">technique</a>;
<a name="l00080"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#a95d825983c923b6dcd7dfd7665486578">00080</a>         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* <a class="code" href="structOgre_1_1MaterialScriptContext.html#a95d825983c923b6dcd7dfd7665486578">pass</a>;
<a name="l00081"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#add408689df9b6e92b2e27a4f60fc4b50">00081</a>         <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* <a class="code" href="structOgre_1_1MaterialScriptContext.html#add408689df9b6e92b2e27a4f60fc4b50">textureUnit</a>;
<a name="l00082"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#a850fb30625648afc080c4d9260c256f6">00082</a>         <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a> <a class="code" href="structOgre_1_1MaterialScriptContext.html#a850fb30625648afc080c4d9260c256f6">program</a>; <span class="comment">// used when referencing a program, not when defining it</span>
<a name="l00083"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#af74e7eb288bf216915e3f483973fc117">00083</a>         <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1MaterialScriptContext.html#af74e7eb288bf216915e3f483973fc117">isVertexProgramShadowCaster</a>; <span class="comment">// when referencing, are we in context of shadow caster</span>
<a name="l00084"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#a40429f8e68082431de156a11139ad92f">00084</a>         <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1MaterialScriptContext.html#a40429f8e68082431de156a11139ad92f">isFragmentProgramShadowCaster</a>; <span class="comment">// when referencing, are we in context of shadow caster</span>
<a name="l00085"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#aea3c8c3bfc642b51b2e491f978acc7e1">00085</a>         <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1MaterialScriptContext.html#aea3c8c3bfc642b51b2e491f978acc7e1">isVertexProgramShadowReceiver</a>; <span class="comment">// when referencing, are we in context of shadow caster</span>
<a name="l00086"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#a23f6f4cb57e74ef76b4779887e2d4a99">00086</a>         <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1MaterialScriptContext.html#a23f6f4cb57e74ef76b4779887e2d4a99">isFragmentProgramShadowReceiver</a>; <span class="comment">// when referencing, are we in context of shadow caster</span>
<a name="l00087"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#a40b6666c05a0603b3fb92cdac9e92e3c">00087</a>         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> <a class="code" href="structOgre_1_1MaterialScriptContext.html#a40b6666c05a0603b3fb92cdac9e92e3c">programParams</a>;
<a name="l00088"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#a735dfeecb720e45e7e59716b5e48a4e6">00088</a>         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="structOgre_1_1MaterialScriptContext.html#a735dfeecb720e45e7e59716b5e48a4e6">numAnimationParametrics</a>;
<a name="l00089"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#a2dfe774e6ce488e92e615fb17bba9e07">00089</a>         <a class="code" href="structOgre_1_1MaterialScriptProgramDefinition.html" title="Struct for holding a program definition which is in progress.">MaterialScriptProgramDefinition</a>* <a class="code" href="structOgre_1_1MaterialScriptContext.html#a2dfe774e6ce488e92e615fb17bba9e07">programDef</a>; <span class="comment">// this is used while defining a program</span>
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#a0d561091772b7bdd98c89cf3e469d078">00091</a>         <span class="keywordtype">int</span> <a class="code" href="structOgre_1_1MaterialScriptContext.html#a0d561091772b7bdd98c89cf3e469d078">techLev</a>,    <span class="comment">//Keep track of what tech, pass, and state level we are in</span>
<a name="l00092"></a>00092             <a class="code" href="structOgre_1_1MaterialScriptContext.html#a9d9306c507a66909313bc2153f57265b">passLev</a>,
<a name="l00093"></a>00093             <a class="code" href="structOgre_1_1MaterialScriptContext.html#af315446811bd4d226027fea8689b6dd0">stateLev</a>;
<a name="l00094"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#acfa11da8b33a1fd4c07527bbb3d17772">00094</a>         <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> <a class="code" href="structOgre_1_1MaterialScriptContext.html#acfa11da8b33a1fd4c07527bbb3d17772">defaultParamLines</a>;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096         <span class="comment">// Error reporting state</span>
<a name="l00097"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#ac5d56f2bd830b49be1f22d86ac8fb7e0">00097</a>         <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1MaterialScriptContext.html#ac5d56f2bd830b49be1f22d86ac8fb7e0">lineNo</a>;
<a name="l00098"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#ad89800f3f468929055abc5e2bafc0d4d">00098</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1MaterialScriptContext.html#ad89800f3f468929055abc5e2bafc0d4d">filename</a>;
<a name="l00099"></a><a class="code" href="structOgre_1_1MaterialScriptContext.html#a3c2c6c2dca3a9d723be0c0a36113c3ab">00099</a>         <a class="code" href="group__General.html#ga20898062bd79359acd1137276d9b0e37" title="Alias / Texture name pair (first = alias, second = texture name)">AliasTextureNamePairList</a> <a class="code" href="structOgre_1_1MaterialScriptContext.html#a3c2c6c2dca3a9d723be0c0a36113c3ab">textureAliases</a>;
<a name="l00100"></a>00100     };
<a name="l00102"></a><a class="code" href="group__Materials.html#ga315137b78f2d739ab0e41e07b1fcf51d">00102</a>     <span class="keyword">typedef</span> bool (*<a class="code" href="group__Materials.html#ga315137b78f2d739ab0e41e07b1fcf51d" title="Function def for material attribute parser; return value determines if the next line should be {...">ATTRIBUTE_PARSER</a>)(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; params, <a class="code" href="structOgre_1_1MaterialScriptContext.html" title="Struct for holding the script context while parsing.">MaterialScriptContext</a>&amp; context);
<a name="l00103"></a>00103 
<a name="l00105"></a><a class="code" href="classOgre_1_1MaterialSerializer.html">00105</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SerializerAlloc</a>
<a name="l00106"></a>00106     {   
<a name="l00107"></a>00107     <span class="keyword">public</span>:
<a name="l00108"></a>00108 
<a name="l00109"></a>00109         <span class="comment">// Material serizliae event.</span>
<a name="l00110"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">00110</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">SerializeEvent</a>
<a name="l00111"></a>00111         {
<a name="l00112"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4ba85e77d983816f0d99a6cc14252b5c62d">00112</a>             <a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4ba85e77d983816f0d99a6cc14252b5c62d">MSE_PRE_WRITE</a>,
<a name="l00113"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4bad618010e51ad0134e4b0030894d5f77d">00113</a>             <a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4bad618010e51ad0134e4b0030894d5f77d">MSE_WRITE_BEGIN</a>,
<a name="l00114"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4ba297d0688ca8bd49478cab6050456ffdf">00114</a>             <a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4ba297d0688ca8bd49478cab6050456ffdf">MSE_WRITE_END</a>,
<a name="l00115"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4ba794b95b31d0f4fac1a6cb29f13b11e1a">00115</a>             MSE_POST_WRITE
<a name="l00116"></a>00116         };
<a name="l00117"></a>00117 
<a name="l00121"></a><a class="code" href="classOgre_1_1MaterialSerializer_1_1Listener.html">00121</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1MaterialSerializer_1_1Listener.html" title="Class that allows listening in on the various stages of material serialization process.">Listener</a>
<a name="l00122"></a>00122         {
<a name="l00123"></a>00123         <span class="keyword">public</span>:
<a name="l00124"></a><a class="code" href="classOgre_1_1MaterialSerializer_1_1Listener.html#a13e6cb61dc6c4c5663de032e8d027551">00124</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MaterialSerializer_1_1Listener.html#a13e6cb61dc6c4c5663de032e8d027551">~Listener</a>() {}
<a name="l00125"></a>00125             
<a name="l00133"></a><a class="code" href="classOgre_1_1MaterialSerializer_1_1Listener.html#a12692ae5f00a3012d83342ab7539dadd">00133</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> materialEventRaised(<a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>* ser, 
<a name="l00134"></a>00134                 <a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>* mat)
<a name="l00135"></a>00135                         { (void)ser; (void)event; (void)skip; (void)mat; }
<a name="l00136"></a>00136             
<a name="l00144"></a><a class="code" href="classOgre_1_1MaterialSerializer_1_1Listener.html#ae25d7325accb65561cab814d2731530f">00144</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> techniqueEventRaised(<a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>* ser, 
<a name="l00145"></a>00145                 <a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* tech)
<a name="l00146"></a>00146                         { (void)ser; (void)event; (void)skip; (void)tech; }
<a name="l00147"></a>00147         
<a name="l00155"></a><a class="code" href="classOgre_1_1MaterialSerializer_1_1Listener.html#a22fbc4529e17ce36172a890868973d6c">00155</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> passEventRaised(<a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>* ser, 
<a name="l00156"></a>00156                 <a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pass)
<a name="l00157"></a>00157                         { (void)ser; (void)event; (void)skip; (void)pass; }
<a name="l00158"></a>00158 
<a name="l00169"></a><a class="code" href="classOgre_1_1MaterialSerializer_1_1Listener.html#a192341794a44b9096b891b676be06b35">00169</a>             <span class="keywordtype">void</span> gpuProgramRefEventRaised(<a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>* ser, 
<a name="l00170"></a>00170                 <a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip,
<a name="l00171"></a>00171                 <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; attrib, 
<a name="l00172"></a>00172                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; program, 
<a name="l00173"></a>00173                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a>&amp; params,
<a name="l00174"></a>00174                 <a class="code" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>* defaultParams)
<a name="l00175"></a>00175                         {
<a name="l00176"></a>00176                             (void)ser;
<a name="l00177"></a>00177                             (void)event;
<a name="l00178"></a>00178                             (void)skip;
<a name="l00179"></a>00179                             (void)attrib;
<a name="l00180"></a>00180                             (void)program;
<a name="l00181"></a>00181                             (void)params;
<a name="l00182"></a>00182                             (void)defaultParams;
<a name="l00183"></a>00183                         }
<a name="l00184"></a>00184 
<a name="l00192"></a><a class="code" href="classOgre_1_1MaterialSerializer_1_1Listener.html#a6d101b60cbb7b19a25ae7bf030552b1a">00192</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> textureUnitStateEventRaised(<a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>* ser, 
<a name="l00193"></a>00193                 <a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* textureUnit)
<a name="l00194"></a>00194                         {
<a name="l00195"></a>00195                             (void)ser;
<a name="l00196"></a>00196                             (void)event;
<a name="l00197"></a>00197                             (void)skip;
<a name="l00198"></a>00198                             (void)textureUnit;
<a name="l00199"></a>00199                         }           
<a name="l00200"></a>00200         };
<a name="l00201"></a>00201 
<a name="l00202"></a>00202     <span class="keyword">protected</span>:
<a name="l00204"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a22de02f9f67c8c2e9121603f3a6f796f">00204</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, ATTRIBUTE_PARSER&gt;::type</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#a22de02f9f67c8c2e9121603f3a6f796f" title="Keyword-mapped attribute parsers.">AttribParserList</a>;
<a name="l00205"></a>00205 
<a name="l00206"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#acb3ce66fb6061378fc8b8213a52e1b29">00206</a>         <a class="code" href="structOgre_1_1MaterialScriptContext.html" title="Struct for holding the script context while parsing.">MaterialScriptContext</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#acb3ce66fb6061378fc8b8213a52e1b29">mScriptContext</a>;
<a name="l00207"></a>00207 
<a name="l00211"></a>00211         <span class="keywordtype">bool</span> parseScriptLine(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; line);
<a name="l00213"></a>00213         <span class="keywordtype">bool</span> invokeParser(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; line, <a class="code" href="classOgre_1_1MaterialSerializer.html#a22de02f9f67c8c2e9121603f3a6f796f" title="Keyword-mapped attribute parsers.">AttribParserList</a>&amp; parsers);
<a name="l00217"></a>00217         <span class="keywordtype">void</span> finishProgramDefinition(<span class="keywordtype">void</span>);
<a name="l00219"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a8dcdf570027a4ebca1e9f24477196f79">00219</a>         <a class="code" href="classOgre_1_1MaterialSerializer.html#a22de02f9f67c8c2e9121603f3a6f796f" title="Keyword-mapped attribute parsers.">AttribParserList</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#a8dcdf570027a4ebca1e9f24477196f79" title="Parsers for the root of the material script.">mRootAttribParsers</a>;
<a name="l00221"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a6176ae9c2f30c75ec75246688cb2c119">00221</a>         <a class="code" href="classOgre_1_1MaterialSerializer.html#a22de02f9f67c8c2e9121603f3a6f796f" title="Keyword-mapped attribute parsers.">AttribParserList</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#a6176ae9c2f30c75ec75246688cb2c119" title="Parsers for the material section of a script.">mMaterialAttribParsers</a>;
<a name="l00223"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#aac52f8be826c32f861530c7155b439af">00223</a>         <a class="code" href="classOgre_1_1MaterialSerializer.html#a22de02f9f67c8c2e9121603f3a6f796f" title="Keyword-mapped attribute parsers.">AttribParserList</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#aac52f8be826c32f861530c7155b439af" title="Parsers for the technique section of a script.">mTechniqueAttribParsers</a>;
<a name="l00225"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a76790b4bb4ec5867feebb8a8a01acb92">00225</a>         <a class="code" href="classOgre_1_1MaterialSerializer.html#a22de02f9f67c8c2e9121603f3a6f796f" title="Keyword-mapped attribute parsers.">AttribParserList</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#a76790b4bb4ec5867feebb8a8a01acb92" title="Parsers for the pass section of a script.">mPassAttribParsers</a>;
<a name="l00227"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a91976b3d3eef680f9b0191c1cda408ee">00227</a>         <a class="code" href="classOgre_1_1MaterialSerializer.html#a22de02f9f67c8c2e9121603f3a6f796f" title="Keyword-mapped attribute parsers.">AttribParserList</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#a91976b3d3eef680f9b0191c1cda408ee" title="Parsers for the texture unit section of a script.">mTextureUnitAttribParsers</a>;
<a name="l00229"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#ad09f2012ba87dde9e7d370b1398cc05a">00229</a>         <a class="code" href="classOgre_1_1MaterialSerializer.html#a22de02f9f67c8c2e9121603f3a6f796f" title="Keyword-mapped attribute parsers.">AttribParserList</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#ad09f2012ba87dde9e7d370b1398cc05a" title="Parsers for the program reference section of a script.">mProgramRefAttribParsers</a>;
<a name="l00231"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a806eb780cff4163bdfc3c445fcdc12ae">00231</a>         <a class="code" href="classOgre_1_1MaterialSerializer.html#a22de02f9f67c8c2e9121603f3a6f796f" title="Keyword-mapped attribute parsers.">AttribParserList</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#a806eb780cff4163bdfc3c445fcdc12ae" title="Parsers for the program definition section of a script.">mProgramAttribParsers</a>;
<a name="l00233"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a7732e09b00b9416fd06a4ff0b12448c9">00233</a>         <a class="code" href="classOgre_1_1MaterialSerializer.html#a22de02f9f67c8c2e9121603f3a6f796f" title="Keyword-mapped attribute parsers.">AttribParserList</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#a7732e09b00b9416fd06a4ff0b12448c9" title="Parsers for the program definition section of a script.">mProgramDefaultParamAttribParsers</a>;
<a name="l00234"></a>00234 
<a name="l00236"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a297f9015444c12452387eb2ab9f3c0f0">00236</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Listener*&gt;::type</a>         <a class="code" href="classOgre_1_1MaterialSerializer.html#a297f9015444c12452387eb2ab9f3c0f0" title="Listeners list of this Serializer.">ListenerList</a>;
<a name="l00237"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a028c6b30b888d03c4120f535eace5382">00237</a>         <span class="keyword">typedef</span> ListenerList::iterator          <a class="code" href="classOgre_1_1MaterialSerializer.html#a028c6b30b888d03c4120f535eace5382">ListenerListIterator</a>;
<a name="l00238"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a06bad7ecd388d210ec091003d57daccf">00238</a>         <span class="keyword">typedef</span> ListenerList::const_iterator    <a class="code" href="classOgre_1_1MaterialSerializer.html#a06bad7ecd388d210ec091003d57daccf">ListenerListConstIterator</a>;
<a name="l00239"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#ae350bc1a66e327cf4a77a12e50ccf726">00239</a>         <a class="code" href="classOgre_1_1MaterialSerializer.html#a297f9015444c12452387eb2ab9f3c0f0" title="Listeners list of this Serializer.">ListenerList</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#ae350bc1a66e327cf4a77a12e50ccf726">mListeners</a>;
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 
<a name="l00242"></a>00242         <span class="keywordtype">void</span> writeMaterial(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; pMat, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; materialName = <span class="stringliteral">&quot;&quot;</span>);
<a name="l00243"></a>00243         <span class="keywordtype">void</span> writeTechnique(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* pTech);
<a name="l00244"></a>00244         <span class="keywordtype">void</span> writePass(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pPass);
<a name="l00245"></a>00245         <span class="keywordtype">void</span> writeVertexProgramRef(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pPass);
<a name="l00246"></a>00246         <span class="keywordtype">void</span> writeShadowCasterVertexProgramRef(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pPass);
<a name="l00247"></a>00247         <span class="keywordtype">void</span> writeShadowCasterFragmentProgramRef(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pPass);
<a name="l00248"></a>00248         <span class="keywordtype">void</span> writeShadowReceiverVertexProgramRef(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pPass);
<a name="l00249"></a>00249         <span class="keywordtype">void</span> writeShadowReceiverFragmentProgramRef(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pPass);
<a name="l00250"></a>00250         <span class="keywordtype">void</span> writeFragmentProgramRef(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pPass);
<a name="l00251"></a>00251         <span class="keywordtype">void</span> writeGpuProgramRef(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; attrib, <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; program, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a>&amp; params);
<a name="l00252"></a>00252         <span class="keywordtype">void</span> writeGpuPrograms(<span class="keywordtype">void</span>);
<a name="l00253"></a>00253         <span class="keywordtype">void</span> writeGPUProgramParameters(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a>&amp; params, <a class="code" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>* defaultParams,
<a name="l00254"></a>00254             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> level = 4, <span class="keyword">const</span> <span class="keywordtype">bool</span> useMainBuffer = <span class="keyword">true</span>);
<a name="l00255"></a>00255         <span class="keywordtype">void</span> writeNamedGpuProgramParameters(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a>&amp; params, <a class="code" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>* defaultParams,
<a name="l00256"></a>00256             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> level = 4, <span class="keyword">const</span> <span class="keywordtype">bool</span> useMainBuffer = <span class="keyword">true</span>);
<a name="l00257"></a>00257         <span class="keywordtype">void</span> writeLowLevelGpuProgramParameters(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a>&amp; params, <a class="code" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>* defaultParams,
<a name="l00258"></a>00258             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> level = 4, <span class="keyword">const</span> <span class="keywordtype">bool</span> useMainBuffer = <span class="keyword">true</span>);
<a name="l00259"></a>00259         <span class="keywordtype">void</span> writeGpuProgramParameter(
<a name="l00260"></a>00260             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; commandName, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; identifier, 
<a name="l00261"></a>00261             <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html" title="Structure recording the use of an automatic parameter.">GpuProgramParameters::AutoConstantEntry</a>* autoEntry, 
<a name="l00262"></a>00262             <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html" title="Structure recording the use of an automatic parameter.">GpuProgramParameters::AutoConstantEntry</a>* defaultAutoEntry, 
<a name="l00263"></a>00263             <span class="keywordtype">bool</span> isFloat, <span class="keywordtype">size_t</span> physicalIndex, <span class="keywordtype">size_t</span> physicalSize,
<a name="l00264"></a>00264             <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a>&amp; params, <a class="code" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>* defaultParams,
<a name="l00265"></a>00265             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> level, <span class="keyword">const</span> <span class="keywordtype">bool</span> useMainBuffer);
<a name="l00266"></a>00266         <span class="keywordtype">void</span> writeTextureUnit(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a> *pTex);
<a name="l00267"></a>00267         <span class="keywordtype">void</span> writeSceneBlendFactor(<span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> c_src, <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> c_dest, 
<a name="l00268"></a>00268             <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> a_src, <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> a_dest);
<a name="l00269"></a>00269         <span class="keywordtype">void</span> writeSceneBlendFactor(<span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sbf_src, <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sbf_dest);
<a name="l00270"></a>00270         <span class="keywordtype">void</span> writeSceneBlendFactor(<span class="keyword">const</span> <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sbf);
<a name="l00271"></a>00271         <span class="keywordtype">void</span> writeCompareFunction(<span class="keyword">const</span> <a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> cf);
<a name="l00272"></a>00272         <span class="keywordtype">void</span> writeColourValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;colour, <span class="keywordtype">bool</span> writeAlpha = <span class="keyword">false</span>);
<a name="l00273"></a>00273         <span class="keywordtype">void</span> writeLayerBlendOperationEx(<span class="keyword">const</span> <a class="code" href="group__Materials.html#ga264ecab38a04d01e2c3158fa05ec1ee2" title="Expert list of valid texture blending operations, for use with TextureUnitState::setColourOperationEx...">LayerBlendOperationEx</a> op);
<a name="l00274"></a>00274         <span class="keywordtype">void</span> writeLayerBlendSource(<span class="keyword">const</span> <a class="code" href="group__Materials.html#gae2ad78de344f35307ce35157c175625e" title="List of valid sources of values for blending operations used in TextureUnitState::setColourOperation ...">LayerBlendSource</a> lbs);
<a name="l00275"></a>00275         
<a name="l00276"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a600190cf43afed4cf6e33d5dd048a4a0">00276</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1multimap.html#abbc044dc966133fc43888a7c8cad6237">multimap&lt;TextureUnitState::TextureEffectType, TextureUnitState::TextureEffect&gt;::type</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#a600190cf43afed4cf6e33d5dd048a4a0">EffectMap</a>;
<a name="l00277"></a>00277 
<a name="l00278"></a>00278         <span class="keywordtype">void</span> writeRotationEffect(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html" title="Internal structure defining a texture effect.">TextureUnitState::TextureEffect</a>&amp; effect, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a> *pTex);
<a name="l00279"></a>00279         <span class="keywordtype">void</span> writeTransformEffect(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html" title="Internal structure defining a texture effect.">TextureUnitState::TextureEffect</a>&amp; effect, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a> *pTex);
<a name="l00280"></a>00280         <span class="keywordtype">void</span> writeScrollEffect(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html" title="Internal structure defining a texture effect.">TextureUnitState::TextureEffect</a>&amp; effect, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a> *pTex);
<a name="l00281"></a>00281         <span class="keywordtype">void</span> writeEnvironmentMapEffect(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html" title="Internal structure defining a texture effect.">TextureUnitState::TextureEffect</a>&amp; effect, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a> *pTex);
<a name="l00282"></a>00282 
<a name="l00283"></a>00283         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> convertFiltering(<a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> fo);
<a name="l00284"></a>00284 
<a name="l00285"></a>00285         
<a name="l00289"></a>00289         <span class="keywordtype">void</span> fireMaterialEvent(<a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>* mat);
<a name="l00290"></a>00290 
<a name="l00294"></a>00294         <span class="keywordtype">void</span> fireTechniqueEvent(<a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* tech);
<a name="l00295"></a>00295         
<a name="l00299"></a>00299         <span class="keywordtype">void</span> firePassEvent(<a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pass);
<a name="l00300"></a>00300         
<a name="l00304"></a>00304         <span class="keywordtype">void</span> fireGpuProgramRefEvent(<a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip,
<a name="l00305"></a>00305             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; attrib, 
<a name="l00306"></a>00306             <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; program, 
<a name="l00307"></a>00307             <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a>&amp; params,
<a name="l00308"></a>00308             <a class="code" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>* defaultParams);
<a name="l00309"></a>00309     
<a name="l00310"></a>00310 
<a name="l00314"></a>00314         <span class="keywordtype">void</span> fireTextureUnitStateEvent(<a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* textureUnit);
<a name="l00315"></a>00315         
<a name="l00316"></a>00316    <span class="keyword">public</span>:      
<a name="l00318"></a>00318         <a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>();
<a name="l00320"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#ad933634a0807f52b41c490536345d19b">00320</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MaterialSerializer.html#ad933634a0807f52b41c490536345d19b" title="default destructor">~MaterialSerializer</a>() {}
<a name="l00321"></a>00321 
<a name="l00330"></a>00330         <span class="keywordtype">void</span> queueForExport(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; pMat, <span class="keywordtype">bool</span> clearQueued = <span class="keyword">false</span>, 
<a name="l00331"></a>00331             <span class="keywordtype">bool</span> exportDefaults = <span class="keyword">false</span>, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; materialName = <span class="stringliteral">&quot;&quot;</span>);
<a name="l00341"></a>00341         <span class="keywordtype">void</span> exportQueued(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename, <span class="keyword">const</span> <span class="keywordtype">bool</span> includeProgDef = <span class="keyword">false</span>, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; programFilename = <span class="stringliteral">&quot;&quot;</span>);
<a name="l00353"></a>00353         <span class="keywordtype">void</span> exportMaterial(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; pMat, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename, <span class="keywordtype">bool</span> exportDefaults = <span class="keyword">false</span>,
<a name="l00354"></a>00354             <span class="keyword">const</span> <span class="keywordtype">bool</span> includeProgDef = <span class="keyword">false</span>, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; programFilename = <span class="stringliteral">&quot;&quot;</span>, 
<a name="l00355"></a>00355             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; materialName = <span class="stringliteral">&quot;&quot;</span>);
<a name="l00357"></a>00357         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;getQueuedAsString() <span class="keyword">const</span>;
<a name="l00359"></a>00359         <span class="keywordtype">void</span> clearQueue();
<a name="l00360"></a>00360 
<a name="l00363"></a>00363         <span class="keywordtype">void</span> parseScript(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName);
<a name="l00364"></a>00364 
<a name="l00368"></a>00368         <span class="keywordtype">void</span> addListener(Listener* listener);
<a name="l00369"></a>00369 
<a name="l00373"></a>00373         <span class="keywordtype">void</span> removeListener(Listener* listener);
<a name="l00374"></a>00374 
<a name="l00375"></a>00375     <span class="keyword">private</span>:
<a name="l00376"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a6a08d7eedc3db673013079c3ab8dc5ec">00376</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#a6a08d7eedc3db673013079c3ab8dc5ec">mBuffer</a>;
<a name="l00377"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#afd3d781433ebcb52094a4dd1695ccd4c">00377</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#afd3d781433ebcb52094a4dd1695ccd4c">mGpuProgramBuffer</a>;
<a name="l00378"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a914b4ebf382eb560b700a13c2a78aaf9">00378</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;String&gt;::type</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#a914b4ebf382eb560b700a13c2a78aaf9">GpuProgramDefinitionContainer</a>;
<a name="l00379"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#aa99b888e44270f3222342d75991bc9de">00379</a>         <span class="keyword">typedef</span> GpuProgramDefinitionContainer::iterator <a class="code" href="classOgre_1_1MaterialSerializer.html#aa99b888e44270f3222342d75991bc9de">GpuProgramDefIterator</a>;
<a name="l00380"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#af76f01904022aff94c3b92f19f4e714b">00380</a>         <a class="code" href="classOgre_1_1MaterialSerializer.html#a914b4ebf382eb560b700a13c2a78aaf9">GpuProgramDefinitionContainer</a> <a class="code" href="classOgre_1_1MaterialSerializer.html#af76f01904022aff94c3b92f19f4e714b">mGpuProgramDefinitionContainer</a>;
<a name="l00381"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#ab0fd51026108690c261cc4ca71589df6">00381</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MaterialSerializer.html#ab0fd51026108690c261cc4ca71589df6">mDefaults</a>;
<a name="l00382"></a>00382         
<a name="l00383"></a>00383     <span class="keyword">public</span>:
<a name="l00384"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a96e9de7a16458947c9d4208a8be2847b">00384</a>         <span class="keywordtype">void</span> beginSection(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> level, <span class="keyword">const</span> <span class="keywordtype">bool</span> useMainBuffer = <span class="keyword">true</span>)
<a name="l00385"></a>00385         {
<a name="l00386"></a>00386             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; buffer = (useMainBuffer ? mBuffer : mGpuProgramBuffer);
<a name="l00387"></a>00387             buffer += <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00388"></a>00388             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> i = 0; i &lt; level; ++i)
<a name="l00389"></a>00389             {
<a name="l00390"></a>00390                 buffer += <span class="stringliteral">&quot;\t&quot;</span>;
<a name="l00391"></a>00391             }
<a name="l00392"></a>00392             buffer += <span class="stringliteral">&quot;{&quot;</span>;
<a name="l00393"></a>00393         }
<a name="l00394"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#adf543cc3f4c912ef1035f07cc542d78b">00394</a>         <span class="keywordtype">void</span> endSection(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> level, <span class="keyword">const</span> <span class="keywordtype">bool</span> useMainBuffer = <span class="keyword">true</span>)
<a name="l00395"></a>00395         {
<a name="l00396"></a>00396             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; buffer = (useMainBuffer ? mBuffer : mGpuProgramBuffer);
<a name="l00397"></a>00397             buffer += <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00398"></a>00398             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> i = 0; i &lt; level; ++i)
<a name="l00399"></a>00399             {
<a name="l00400"></a>00400                 buffer += <span class="stringliteral">&quot;\t&quot;</span>;
<a name="l00401"></a>00401             }
<a name="l00402"></a>00402             buffer += <span class="stringliteral">&quot;}&quot;</span>;
<a name="l00403"></a>00403         }
<a name="l00404"></a>00404 
<a name="l00405"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#a4e3913738dc6322b8f07a730a14d8951">00405</a>         <span class="keywordtype">void</span> writeAttribute(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> level, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; att, <span class="keyword">const</span> <span class="keywordtype">bool</span> useMainBuffer = <span class="keyword">true</span>)
<a name="l00406"></a>00406         {
<a name="l00407"></a>00407             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; buffer = (useMainBuffer ? mBuffer : mGpuProgramBuffer);
<a name="l00408"></a>00408             buffer += <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00409"></a>00409             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> i = 0; i &lt; level; ++i)
<a name="l00410"></a>00410             {
<a name="l00411"></a>00411                 buffer += <span class="stringliteral">&quot;\t&quot;</span>;
<a name="l00412"></a>00412             }
<a name="l00413"></a>00413             buffer += att;
<a name="l00414"></a>00414         }
<a name="l00415"></a>00415 
<a name="l00416"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#ad7221314131e7f6a76c864fbd3b5d0c7">00416</a>         <span class="keywordtype">void</span> writeValue(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val, <span class="keyword">const</span> <span class="keywordtype">bool</span> useMainBuffer = <span class="keyword">true</span>)
<a name="l00417"></a>00417         {
<a name="l00418"></a>00418             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; buffer = (useMainBuffer ? mBuffer : mGpuProgramBuffer);
<a name="l00419"></a>00419             buffer += (<span class="stringliteral">&quot; &quot;</span> + val);
<a name="l00420"></a>00420         }
<a name="l00421"></a>00421 
<a name="l00422"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#aabdeca87659895ccbcb7756f24818739">00422</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> quoteWord(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val)
<a name="l00423"></a>00423         {
<a name="l00424"></a>00424             <span class="keywordflow">if</span> (val.find_first_of(<span class="stringliteral">&quot; \t&quot;</span>) != String::npos)
<a name="l00425"></a>00425                 <span class="keywordflow">return</span> (<span class="stringliteral">&quot;\&quot;&quot;</span> + val + <span class="stringliteral">&quot;\&quot;&quot;</span>);
<a name="l00426"></a>00426             <span class="keywordflow">else</span> <span class="keywordflow">return</span> val;
<a name="l00427"></a>00427         }
<a name="l00428"></a>00428 
<a name="l00429"></a>00429 
<a name="l00430"></a><a class="code" href="classOgre_1_1MaterialSerializer.html#ac4add46c30786c566425b8cd9904f032">00430</a>         <span class="keywordtype">void</span> writeComment(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> level, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; comment, <span class="keyword">const</span> <span class="keywordtype">bool</span> useMainBuffer = <span class="keyword">true</span>)
<a name="l00431"></a>00431         {
<a name="l00432"></a>00432             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; buffer = (useMainBuffer ? mBuffer : mGpuProgramBuffer);
<a name="l00433"></a>00433             buffer += <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00434"></a>00434             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> i = 0; i &lt; level; ++i)
<a name="l00435"></a>00435             {
<a name="l00436"></a>00436                 buffer += <span class="stringliteral">&quot;\t&quot;</span>;
<a name="l00437"></a>00437             }
<a name="l00438"></a>00438             buffer += <span class="stringliteral">&quot;// &quot;</span> + comment;
<a name="l00439"></a>00439         }
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 
<a name="l00442"></a>00442 
<a name="l00443"></a>00443     };
<a name="l00446"></a>00446 }
<a name="l00447"></a>00447 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
